import xbmc
import xbmcaddon
import os
import sys

# Imports for mail transfer (considering UTF8 and German Umlaute)
import smtplib
from cStringIO import StringIO
from email.mime.multipart import MIMEMultipart
from email.mime.text import MIMEText
from email.header import Header
from email import Charset
from email.generator import Generator

# Unicode Workaround (Umlaute etc.)
import sys
reload(sys)
sys.setdefaultencoding("utf-8")

#########################
# Init
#########################
addon = xbmcaddon.Addon(id='service.epg-movie-mailer')
addon_name = addon.getAddonInfo('name')
addon_id = addon.getAddonInfo('id')
addon_version = addon.getAddonInfo('version')
addon_icon = addon.getAddonInfo('icon')
addon_path = addon.getAddonInfo('path')
addon_cachedir = addon.getAddonInfo('profile')
addon_settings = addon.getSetting

#########################
# Configuration
#########################
# Mail configuration
mail_username = addon_settings('mail_username')
mail_password = addon_settings('mail_password')
mail_smtp_server = addon_settings('mail_smtp_server')
mail_address = [addon_settings('mail_sender_name'), addon_settings('mail_sender')]
mail_recipient = [addon_settings('mail_recipient_name'), addon_settings('mail_recipient')]
mail_subject = "Email Check - EPG Movie Mailer"


#########################
# Logging and Notification
#########################
def log(description):
  xbmc.log("[DEBUG] '%s v%s': %s" % (addon_name, addon_version, description.encode('ascii', 'ignore')), xbmc.LOGNOTICE)


def notification(title, message, image=addon_icon, displaytime=6000):
  xbmc.executeJSONRPC('{"jsonrpc": "2.0", "method": "GUI.ShowNotification", "params": {"title": "%s", "message": "%s", "image": "%s", "displaytime": %i}, "id": "%s"}' % \
                        (title, message, image, displaytime, addon.getAddonInfo('id')))


#########################
# MAIN
#########################
if __name__ == "__main__":

    # Send Mail
    html = "Mailcheck from EPG Movie Mailer - succeeded!"
    htmlpart = MIMEText(html, 'html', 'UTF-8')

    msg = MIMEMultipart('alternative')
    msg['Subject'] = "%s" % Header(mail_subject, 'utf-8')
    # Only descriptive part of recipient and sender shall be encoded, not the email address
    msg['From'] = "\"%s\" <%s>" % (Header(mail_address[0], 'utf-8'), mail_address[1])
    msg['To'] = "\"%s\" <%s>" % (Header(mail_recipient[0], 'utf-8'), mail_recipient[1])

    # Attach both parts
    htmlpart = MIMEText(html, 'html', 'UTF-8')
    msg.attach(htmlpart)

    # Create a generator and flatten message object to 'file~@~Y
    str_io = StringIO()
    g = Generator(str_io, False)
    g.flatten(msg)
    # str_io.getvalue() contains ready to sent message
    try:
      smtp = smtplib.SMTP(mail_smtp_server)
      smtp.login(mail_username,mail_password)
      smtp.sendmail(mail_address[1], mail_recipient[1], str_io.getvalue())
      msg = "Successfully sent email"
      log(msg)
      notification(title=addon_name, message=msg, image=addon_icon, displaytime=6000)
    except smtplib.SMTPException:
      msg = "Error: unable to send email"
      log(msg)
      notification(title=addon_name, message=msg, image=addon_icon, displaytime=6000)
