import xbmc
import xbmcaddon
import os
import sys

#########################
# Init
#########################
addon = xbmcaddon.Addon(id='service.epg-movie-mailer')
addon_name = addon.getAddonInfo('name')
addon_id = addon.getAddonInfo('id')
addon_version = addon.getAddonInfo('version')
addon_icon = addon.getAddonInfo('icon')
addon_path = addon.getAddonInfo('path')
addon_cachedir = addon.getAddonInfo('profile')
addon_settings = addon.getSetting

#########################
# Configuration
#########################
movielist_file = addon_settings('movie_list_file')


#########################
# Logging and Notification
#########################
def log(description):
  xbmc.log("[DEBUG] '%s v%s': %s" % (addon_name, addon_version, description.encode('ascii', 'ignore')), xbmc.LOGNOTICE)


def notification(title, message, image=addon_icon, displaytime=6000):
  xbmc.executeJSONRPC('{"jsonrpc": "2.0", "method": "GUI.ShowNotification", "params": {"title": "%s", "message": "%s", "image": "%s", "displaytime": %i}, "id": "%s"}' % \
                        (title, message, image, displaytime, addon.getAddonInfo('id')))


#########################
# MAIN
#########################
if __name__ == "__main__":
    # Check movie file
    if os.path.isfile(movielist_file):
       msg = "Movie file found: %s" % (movielist_file)
       log(msg)
       notification(title=addon_name, message=msg, image=addon_icon, displaytime=6000)
    else:
       msg = "Movie file NOT found: %s" % (movielist_file)
       log(msg)
       notification(title=addon_name, message=msg, image=addon_icon, displaytime=6000)
